<?php
/*
 * Created on 30 janv. 07
 *
 * To change the template for this generated file go to
 * Window - Preferences - PHPeclipse - PHP - Code Templates
 */

if (!defined('IN_COPPERMINE')) { die('Not in Coppermine...');}
if (!defined('JUPLOAD_PHP')) { die('Not in Jupload...');}


//####################################################################################################
//#################################  INTERNAL VARIABLES  #############################################
//####################################################################################################

$configFileHeader = <<<EOS
<?php
/**
 * Caution: This file is generated from the jupload configuration page of JUpload.
 * 
 * You can update it: all modifications on value of valid Jupload parameters will be kept. Comments will be lost
 * if you save the configuration through the jupload configuration page.
 * 
 * To go to the jupload configuration page :
 * - Connect as an admin,
 * - Click on configuration, then General, then 'plugin management',
 * - Click on the 'Jupload Configuration' button that should appear, if JUpload is installed.
 * 
 * This file was saved at: $dateTime
 * 
 * 
 * TODO: remove the html tags in this file. One day, perhaps ...
 * 
 */



EOS
;

//####################################################################################################
//#################################    FUNCTIONS    ##################################################
//####################################################################################################

/**
 * mergePostDataWithConfig will read post data, and store them into the $JUPLOAD_CONFIG array.
 */
function mergePostDataWithConfig() {
	global $JUploadParamList, $JUPLOAD_CONFIG;

	$htmlResult = '';
	
	//We read the post data. From them, we only take care of the parameters defined in the $JUploadParamList array.
	//But we parse all incoming post data, to display warning if unknown values are coming. These unknown values
	//should only come from bugs. Nobody in the whole world would try to attack a web server ...   ;-)
	foreach ($_POST as $key => $value) {
		//We've read one key. Is it a valid parameter ?
		$validParameter = false;
		foreach ($JUploadParamList as $param) {
			if ($param['name'] == $key) {
				$validParameter = true;
				if ($param['type'] == 'int') {
					$JUPLOAD_CONFIG[$param['name']] = (int) $value;
				} else {
					//Let's manage it as a string. We don't take particular precaution: if the user go to this part
					//of code, then he is an admin. So he can already upload any plugin, that is .. any code.
					$JUPLOAD_CONFIG[$param['name']] = $value;
				}
			}
		}//foreach($JUploadParamList)
		
		//Did we find the parameter ?
		if (!$validParameter) {
			$htmlResult .= "<BR>The post variable '<B>$key</B>' is not a valid parameter for this version of JUpload.";
		}
	}//foreach($_POST)
	
	return $htmlResult;
}

/**
 * writeJuploadConfigFile generates the Jupload config file from the content of the $JUpload_CONFIG array.
 */
function writeJuploadConfigFile() {
	global $JUploadParamList, $JUPLOAD_CONFIG, $configFileHeader;
	$htmlResult = '';  //This string will remain empty if everything is Ok.

	$filename = 'plugins/jupload/user/config.inc.php';
	$h = fopen($filename, 'w');
	if (!$h) {
		$htmlResult = "<FONT color=red>Erreur while opening the file '$filename'</FONT>";
	} else {
		$dateTime = date('j M Y  H:i');
		fwrite($h, $configFileHeader);
		foreach ($JUploadParamList as $param) {
			if (! isset($JUPLOAD_CONFIG[$param['name']])) {
				$JUPLOAD_CONFIG[$param['name']] = $param['default'];
			}
			
			if ($param['type'] == 'int') {
				$val = (int)$JUPLOAD_CONFIG[$param['name']];
			} else {
				//Let's suppose it's a string
				$val = '\'' . $JUPLOAD_CONFIG[str_replace('\'', '\\\'', $param['name'])] . '\'';
			}

			fwrite($h, <<<EOS
/*
${param['desc']}
Default value is '${param['default']}'		
*/
\$JUPLOAD_CONFIG['${param['name']}'] = $val;


EOS
);
		}
	}
	
	return $htmlResult;
}

///////////////////////////////////////////////////////////////////////
/////////////////   MANAGEMENT OF POST DATA        ////////////////////
///////////////////////////////////////////////////////////////////////

if ($action == 'store_config') {
	$htmlPostResult = mergePostDataWithConfig();
	$htmlWriteConfigResult = writeJuploadConfigFile();
}

///////////////////////////////////////////////////////////////////////
///////////////   GENERATION OF THE HTML CONTENT    ///////////////////
///////////////////////////////////////////////////////////////////////

pageheader('JUpload configuration');

echo ('<form method="post" name="form_album" enctype="multipart/form-data" action="index.php?file=jupload/jupload&action=store_config">');
	starttable('100%', 'JUpload configuration', 2);
		if ($htmlPostResult != '') {
			form_statement ("<FONT color=red>An error occured: $htmlPostResult</FONT>");
		}
		if ($htmlWriteConfigResult != '') {
			form_statement ("<FONT color=red>An error occured: $htmlWriteConfigResult</FONT>");
		}
		foreach ($JUploadParamList as $param) {
			form_statement ("<B>${param['name']}</B>");		
			form_statement ($param['desc']);		
			form_statement ("Default value is '${param['default']}'");		
			text_box_input($param['name'], $param['name'], 255, 1, $JUPLOAD_CONFIG[$param['name']]); 
		}
	
		$submit_buttons = array (
			    array('value' => 'Store configuration'),
		    );
		submit_button($submit_buttons);
	endtable();
echo ("</form>");
pagefooter();
ob_end_flush();
